package inria.meije.rc.sugarcubes;

public class EventDecl extends UnaryInstruction
{
    protected String eventName;
    protected transient boolean local = false;
    protected transient boolean external;

    public EventDecl(String localName,Instruction body){ 
        eventName = localName; 
        this.body = body;
    }

    public String toString(){ 
        return "event "+eventName+" in "+body+" end";
    }
    protected Instruction rest(){ 
        return new EventDecl(eventName,body.residual()); 
    }
    protected byte activation(Context context){ 
        external = ((Domain)context).swapEventPresence(eventName,local);
        byte res = body.activ(context);
        local = ((Domain)context).swapEventPresence(eventName,external);
        if(res == STOP) local = false;
        return res;
    }
}
