package inria.meije.rc.sugarcubes.migration;

import inria.meije.rc.sugarcubes.*;
import java.rmi.*;
import java.net.*;
import java.util.*;

abstract public class SugarCubesSender extends Atom implements Runnable
{
    protected SugarCubesServer target = null;
    protected Instruction instructionToSend = null;
    protected String hostName=null;
    protected String targetName=null;

    public SugarCubesSender(){}
    public SugarCubesSender(String host,String target,Instruction instruction){
    	hostName = host;
    	targetName = target;
        instructionToSend = instruction;
    }

    public void connectToServer(){
        try{
            target = (SugarCubesServer)Naming.lookup("//"+hostName+"/"+targetName);
        }
        catch(Exception e){
            System.err.println("RsiServer error:"+e.getMessage());
            e.printStackTrace();
        }
    }
    public void sendInstruction(){
        try{
            if(instructionToSend == null)
                System.err.println("Error while sending instruction: instruction is null");
            else
                target.receiveInstruction(instructionToSend);
        }
        catch(Exception e){
            System.err.println("RsiSender error: "+e.getMessage());
            e.printStackTrace();
        }
    }
    public void run(){synchronized(this){connectToServer();sendInstruction();}}
}
